# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse201(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'datetime',
        'created_by': 'str',
        'updated_at': 'datetime',
        'updated_by': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'project_name': 'str',
        'self_link': 'str',
        'blueprint_id': 'str',
        'name': 'str',
        'description': 'str',
        'version': 'str',
        'content': 'str',
        'status': 'str',
        'version_description': 'str',
        'version_change_log': 'str',
        'valid': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'project_name': 'projectName',
        'self_link': 'selfLink',
        'blueprint_id': 'blueprintId',
        'name': 'name',
        'description': 'description',
        'version': 'version',
        'content': 'content',
        'status': 'status',
        'version_description': 'versionDescription',
        'version_change_log': 'versionChangeLog',
        'valid': 'valid'
    }

    def __init__(self, id=None, created_at=None, created_by=None, updated_at=None, updated_by=None, org_id=None, project_id=None, project_name=None, self_link=None, blueprint_id=None, name=None, description=None, version=None, content=None, status=None, version_description=None, version_change_log=None, valid=None):  # noqa: E501
        """InlineResponse201 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._created_by = None
        self._updated_at = None
        self._updated_by = None
        self._org_id = None
        self._project_id = None
        self._project_name = None
        self._self_link = None
        self._blueprint_id = None
        self._name = None
        self._description = None
        self._version = None
        self._content = None
        self._status = None
        self._version_description = None
        self._version_change_log = None
        self._valid = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if project_name is not None:
            self.project_name = project_name
        if self_link is not None:
            self.self_link = self_link
        if blueprint_id is not None:
            self.blueprint_id = blueprint_id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if version is not None:
            self.version = version
        if content is not None:
            self.content = content
        if status is not None:
            self.status = status
        if version_description is not None:
            self.version_description = version_description
        if version_change_log is not None:
            self.version_change_log = version_change_log
        if valid is not None:
            self.valid = valid

    @property
    def id(self):
        """Gets the id of this InlineResponse201.  # noqa: E501

        Object ID  # noqa: E501

        :return: The id of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse201.

        Object ID  # noqa: E501

        :param id: The id of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this InlineResponse201.  # noqa: E501

        Created time  # noqa: E501

        :return: The created_at of this InlineResponse201.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InlineResponse201.

        Created time  # noqa: E501

        :param created_at: The created_at of this InlineResponse201.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this InlineResponse201.  # noqa: E501

        Created by  # noqa: E501

        :return: The created_by of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this InlineResponse201.

        Created by  # noqa: E501

        :param created_by: The created_by of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_at(self):
        """Gets the updated_at of this InlineResponse201.  # noqa: E501

        Updated time  # noqa: E501

        :return: The updated_at of this InlineResponse201.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InlineResponse201.

        Updated time  # noqa: E501

        :param updated_at: The updated_at of this InlineResponse201.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this InlineResponse201.  # noqa: E501

        Updated by  # noqa: E501

        :return: The updated_by of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this InlineResponse201.

        Updated by  # noqa: E501

        :param updated_by: The updated_by of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def org_id(self):
        """Gets the org_id of this InlineResponse201.  # noqa: E501

        Org ID  # noqa: E501

        :return: The org_id of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this InlineResponse201.

        Org ID  # noqa: E501

        :param org_id: The org_id of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this InlineResponse201.  # noqa: E501

        Project ID  # noqa: E501

        :return: The project_id of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this InlineResponse201.

        Project ID  # noqa: E501

        :param project_id: The project_id of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def project_name(self):
        """Gets the project_name of this InlineResponse201.  # noqa: E501

        Project Name  # noqa: E501

        :return: The project_name of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._project_name

    @project_name.setter
    def project_name(self, project_name):
        """Sets the project_name of this InlineResponse201.

        Project Name  # noqa: E501

        :param project_name: The project_name of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._project_name = project_name

    @property
    def self_link(self):
        """Gets the self_link of this InlineResponse201.  # noqa: E501

        Blueprint version self link  # noqa: E501

        :return: The self_link of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._self_link

    @self_link.setter
    def self_link(self, self_link):
        """Sets the self_link of this InlineResponse201.

        Blueprint version self link  # noqa: E501

        :param self_link: The self_link of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._self_link = self_link

    @property
    def blueprint_id(self):
        """Gets the blueprint_id of this InlineResponse201.  # noqa: E501

        Draft blueprint ID  # noqa: E501

        :return: The blueprint_id of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._blueprint_id

    @blueprint_id.setter
    def blueprint_id(self, blueprint_id):
        """Sets the blueprint_id of this InlineResponse201.

        Draft blueprint ID  # noqa: E501

        :param blueprint_id: The blueprint_id of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._blueprint_id = blueprint_id

    @property
    def name(self):
        """Gets the name of this InlineResponse201.  # noqa: E501

        Blueprint name  # noqa: E501

        :return: The name of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse201.

        Blueprint name  # noqa: E501

        :param name: The name of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this InlineResponse201.  # noqa: E501

        Draft blueprint description  # noqa: E501

        :return: The description of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineResponse201.

        Draft blueprint description  # noqa: E501

        :param description: The description of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def version(self):
        """Gets the version of this InlineResponse201.  # noqa: E501

        Blueprint version  # noqa: E501

        :return: The version of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this InlineResponse201.

        Blueprint version  # noqa: E501

        :param version: The version of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def content(self):
        """Gets the content of this InlineResponse201.  # noqa: E501

        Blueprint YAML content  # noqa: E501

        :return: The content of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this InlineResponse201.

        Blueprint YAML content  # noqa: E501

        :param content: The content of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._content = content

    @property
    def status(self):
        """Gets the status of this InlineResponse201.  # noqa: E501

        Blueprint status  # noqa: E501

        :return: The status of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this InlineResponse201.

        Blueprint status  # noqa: E501

        :param status: The status of this InlineResponse201.  # noqa: E501
        :type: str
        """
        allowed_values = ["DRAFT", "VERSIONED", "RELEASED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def version_description(self):
        """Gets the version_description of this InlineResponse201.  # noqa: E501

        Blueprint version description  # noqa: E501

        :return: The version_description of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._version_description

    @version_description.setter
    def version_description(self, version_description):
        """Sets the version_description of this InlineResponse201.

        Blueprint version description  # noqa: E501

        :param version_description: The version_description of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._version_description = version_description

    @property
    def version_change_log(self):
        """Gets the version_change_log of this InlineResponse201.  # noqa: E501

        Blueprint version change log  # noqa: E501

        :return: The version_change_log of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._version_change_log

    @version_change_log.setter
    def version_change_log(self, version_change_log):
        """Sets the version_change_log of this InlineResponse201.

        Blueprint version change log  # noqa: E501

        :param version_change_log: The version_change_log of this InlineResponse201.  # noqa: E501
        :type: str
        """

        self._version_change_log = version_change_log

    @property
    def valid(self):
        """Gets the valid of this InlineResponse201.  # noqa: E501

        Validation result  # noqa: E501

        :return: The valid of this InlineResponse201.  # noqa: E501
        :rtype: bool
        """
        return self._valid

    @valid.setter
    def valid(self, valid):
        """Sets the valid of this InlineResponse201.

        Validation result  # noqa: E501

        :param valid: The valid of this InlineResponse201.  # noqa: E501
        :type: bool
        """

        self._valid = valid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse201, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse201):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
